<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { inject, ref } from 'vue';
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';
import { request } from '@/lib/request';

const emits = defineEmits<{
    (e: 'close'): void,
    (e: 'success'): void
}>();

const password = ref('');
const showError = ref(false);
const configuration = inject<any>('configuration');

const submit = async () => {
    if (password.value) {
        let response = await request('DELETE', configuration.apiServer + '/api/account/',
            { password: password.value }, 'application/json', false, true);
        if (response && response.success) {
            emits('success');
        } else {
            showError.value = true;
        }
    }
}

const cancel = async () => {
    emits('close');
}

</script>
<template>
    <Modal :header="$t('general.variables.account.sg') + ' ' + $t('general.variables.delete')"
        :labelCancel="$t('general.buttons.cancel')" :labelSubmit="$t('general.buttons.send')"
        :disableSubmit="password.length < 8" @submit="submit" @cancel="cancel">
        <p class="text-red-700 mb-4" v-if="showError">{{ $t('account.reset.error') }}</p>
        <p v-html="$t('account.delete.hint')"></p>
        <div class="mt-2">
            <Input id="password-text-field" v-model="password" type="password" size="w-full"
                :placeholder="$t('general.variables.password.sg')" icon="key" />
        </div>
    </Modal>
</template>